// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <iostream>
#include <cstdlib>
#include <ctime>
#include <cstdio>
//#include <stdlib.h>
#include "pingu.hh"
#include "colmap.hh"

CL_Surface* Pingu::sprite = 0;
CL_Surface* Pingu::fall_sprite = 0; 
ColMap*     Pingu::colmap = 0;
vector<CL_Surface*> Pingu::walker;
vector<CL_Surface*> Pingu::walker_r;
CL_Surface* Pingu::walker_a;

Pingu::Pingu(int x, int y)
{
  //cout << "Pingu.set_pos init" << endl;
  //  sprite = 0;
  alive = true;
  falling = 0;
  direction = left;
  walker_pos = 0;
  //PALETTE pal;
  //datafile = CL_InputSourceProvider::create_datafile_provider("pingus.dat");

  //walker = CL_Sprite::load("walker", datafile);
  //faller = CL_Sprite::load("faller", datafile);
  //sprite = load_pcx("images/pingu.pcx", pal);
  //  fall_sprite = load_pcx("images/PINGU_FALLing.PCX", pal);


  //if (sprite == 0 || fall_sprite == 0) {
    //cerr << "Sceo" << endl;
    // exit(1);
    //  }
  //set_palette(pal);

  //  cout << "Pingu.set_pos init ende" << endl;

  set_pos(x, y);
  falling = 0;
  //id = "New Set_Pos"; 
}

Pingu::Pingu()
{
  //  srand(time(NULL));
  //  cout << "Pingu init" << endl;
  //  sprite = 0;
  alive = true;
  falling = 0;
  direction = left;
  walker_pos = 0;
  //PALETTE pal;

  //sprite = load_pcx("images/pingu.pcx", pal);
  //fall_sprite = load_pcx("images/PINGU_FALLing.PCX", pal);

  /*  if (sprite == 0 || fall_sprite == 0) {
    //fprintf(stderr, "Sceo\n");
    exit(1);
    }*/
  //  cout << "Pingu init ende" << endl;
  //id = "Normal";
}

Pingu::~Pingu()
{
  //  if (sprite) 
    //    destroy_bitmap(sprite);

}

void
Pingu::draw(int x, int y)
{
  if (falling > 2) {
    // cout << "Falling" << endl;

    //!!!!!! wired  !!!!!!!!!!!
    fall_sprite->put_screen(x, y);
    fall_sprite->put_screen(x, y);
    //!!!!!!!!!!!!!!!!!!!!!!!!

  } else {
    //!!!!!! wired  !!!!!!!!!!!
    // walker_a->put_screen(x,y,1);
    //    walker_a->put_screen(x,y,1);
    walker_a->put_screen(x,y,walker_pos 
    			 + ((direction == -1) ? 0 : 3 )
			 );
    walker_a->put_screen(x,y,walker_pos++
    			 + ((direction == -1) ? 0 : 3 )
			 );
    
    if (walker_pos > 2)
      walker_pos = 0;
    /*
    if (direction == left) {
      walker[walker_pos++]->put_screen(x, y);
      
      if (walker_pos > 2)
	 walker_pos = 0;
     } else {
       walker_r[walker_pos++]->put_screen(x, y);
      
       if (walker_pos > 2)
	walker_pos = 0;
	}*/
  }
}

void
Pingu::draw(/*BITMAP* scr*/)
{
  //putpixel(scr, x_pos, y_pos, rand()%255);

  //  cout << "s: Putting Pingu " << x_pos << " " << y_pos << " " << sprite    << endl;
  if (!alive)
    return;

  draw(x_pos-16, y_pos-32);
  //  cout << "f: Putting Pingu" << endl;

  if (falling > 2) {
    //draw_sprite(scr, fall_sprite, x_pos - sprite->w/2, y_pos-sprite->h);
  } else {
    if (direction == left) {
      // draw_sprite
	//	(scr, sprite, x_pos - sprite->w /2 ,  y_pos- sprite->h);
    } else {
      //draw_sprite_h_flip
      //	(scr, sprite, x_pos - sprite->w /2 ,  y_pos- sprite->h);
    }
  }
}

void 
Pingu::set_pos(int x, int y)
{
  x_pos = x;
  y_pos = y;
}

void change(int& dir)
{
  if (dir == left)
    dir = right;
  else
    dir =left;
}

int
Pingu::rel_getpixel(/*BITMAP* col_map,*/ int x, int y)
{
  if (colmap == 0) {
    cout << "Colmap nicht benutzt" << endl;
    exit(EXIT_FAILURE);
  }
  /*
  return getpixel(col_map,
		  x_pos + (x * direction),
		  y_pos + y);
  */
  int return_value;

  return_value = colmap->getpixel(x_pos + (x * direction),
				  (y_pos) - y);

  //if (return_value != 0)
    //    cout << "Solid" << endl;
    
  //cout << return_value;

  return return_value;
    //  return 1;
}


void
Pingu::let_move(void/*BITMAP* col_map*/)
{
  if (!alive) {
    //cout << "One dead Pingu" << endl;
    return;
  }
  
  if (x_pos > 799)
    direction = left;

  if (x_pos < 0)
    direction = right;

  //  x_pos += direction;
  //y_pos += rand()%3 -1;

  if (rel_getpixel(0, -1) == 0) {
    // Pingu is falling
    ++y_pos;
    ++falling;
    //cout <<  "Falling" << endl;
    
  } else {
    if (falling > 100) {
      alive = false;
      return;
  }
  
    falling = 0;
    // Pingu is walking
    if (rel_getpixel(1, 0) == 0) {
      x_pos += direction;    
    } else {
      if (rel_getpixel(1,1)== 0) {
	x_pos += direction;
	y_pos--;
      } else {
	change(direction);
      }
      /*      if (rel_getpixel(1, -1) == 0) {
	--y_pos;
	x_pos += direction;
      } else if (rel_getpixel(1, -2) == 0) {
	y_pos -= 2;
	x_pos += direction;
      } else if (rel_getpixel(1,1) == 0) {
	++y_pos;
	x_pos += direction;*/
    }
  }
}

bool
Pingu::is_alive(void)
{
  return alive;
}

void
Pingu::set_colmap(ColMap* a)
{
  cout << "Colmap gesetzt: " << a << endl;
  colmap = a;
}

/* EOF */
