// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#ifndef PINGU_HH
#define PINGU_HH

#include <ClanLib/clanlib.h>
#include <string>
#include <vector>
#include "colmap.hh"

enum Direction { left = -1, right = 1 };
enum Action {};
enum Action2 {};

// Pingu is the basic object for managing a Pingu. It manage the
// surface the animation and the AI of a pingu, it can also check if
// the pingu is in a given range.

class Pingu
{
public:
  Pingu();
  Pingu(int x, int y);
  ~Pingu();

  int  rel_getpixel(/*BITMAP* col_map,*/ int x, int y);
  void set_pos(int x, int y);
  void let_move(/*BITMAP* col_map*/);
  void draw(/*BITMAP* scr*/);
  void draw(int x, int y);
  bool is_alive(void);

  // some static variables and functions
  static CL_Surface* sprite;
  static CL_Surface* fall_sprite;
  static vector<CL_Surface*> walker;
  static vector<CL_Surface*> walker_r;
  static CL_Surface* walker_a;
  static void set_colmap(ColMap* a);
private:
  static ColMap* colmap;

  int  walker_pos;
  bool alive;
  int x_pos, y_pos;
  int falling;
  int direction;
  //string id;
  
  Action  action;
  Action2 action2;
};

#endif

/* EOF */
